function printtb(t)
local str = "{"
for i,v in pairs(t) do
str = str .. v .. ", "
end
str = str .. "}"
print(str)
end
function checkalldone()
for i,v in pairs(tiles) do
if v.numb == 0 and v.w == false then
return false
end
end
return true
end


function love.load()
print(love.getVersion())
lg = love.graphics
lm = love.mouse
lw = love.window
lk = love.keyboard
lg.setBackgroundColor(0.5, 0.5, 0.5)
lw.setMode(500, 600, {borderless = false})
tiles = {}
for y=0, 19, 1 do
for x=0, 19, 1 do
t = {}
t.x = x*25
t.y = y*25
t.w = false
t.path = false
t.numb = 0
table.insert(tiles, t)
end
target = 0
player = 0
temp = 0
stg = true
search = false
track = false
once = true
tilets = {}
path = {}
end
font = lg.newFont(20)
end

function love.update()
--ENEMY COORD
if lk.isDown("q") and #path == 0 then
for i,v in pairs(tiles) do
local x, y = lm.getX(), lm.getY()
if x > v.x and x < v.x + 25 and y > v.y and y < v.y + 25 and i ~= player and v.w == false then
target = i
end
end
end
--PLAYER COORD
if lk.isDown("w") and #path == 0 then
for i,v in pairs(tiles) do
local x, y = lm.getX(), lm.getY()
if x > v.x and x < v.x + 25 and y > v.y and y < v.y + 25 and i ~= target and v.w == false then
player = i
end
end
end
--ADD WALL
if lm.isDown(1) and #path == 0 then
for i,v in pairs(tiles) do
local x, y = lm.getX(), lm.getY()
if x > v.x and x < v.x + 25 and y > v.y and y < v.y + 25 and i ~= target then
v.w = true
end
end
end
if lm.isDown(2) and #path == 0 then
for i,v in pairs(tiles) do
local x, y = lm.getX(), lm.getY()
if x > v.x and x < v.x + 25 and y > v.y and y < v.y + 25 and i ~= target then
v.w = false
end
end
end
--TOGGLE SEARCH
if lk.isDown("e") and stg and player ~= 0 and target ~= 0 then
search = true
tiles[target].numb = 1
table.insert(tilets, target)
stg = false
end
if lk.isDown("f") then
lw.minimize()
love.event.quit( "restart" )
end

if lk.isDown("escape") then
love.event.quit()
end

local tilets2 = {}
while search do
--ADD VALUE TO EACH TILES (STEP 1)
for i,v in pairs(tilets) do
if tiles[v-1] ~= nil and tiles[v-1].w == false and tiles[v].y - tiles[v-1].y == 0 and tiles[v-1].numb == 0 then
tiles[v-1].numb = tiles[v].numb + 1
table.insert(tilets2, v-1)
end
if tiles[v+1] ~= nil and tiles[v+1].w == false and tiles[v+1].y - tiles[v].y == 0 and tiles[v+1].numb == 0 then
tiles[v+1].numb = tiles[v].numb + 1
table.insert(tilets2, v+1)
end
if tiles[v+20] ~= nil and tiles[v+20].w == false and tiles[v+20].numb == 0 then
tiles[v+20].numb = tiles[v].numb + 1
table.insert(tilets2, v+20)
end
if tiles[v-20] ~= nil and tiles[v-20].w == false and tiles[v-20].numb == 0 then
tiles[v-20].numb = tiles[v].numb + 1
table.insert(tilets2, v-20)
end
end
tilets = tilets2
if checkalldone() and once then
temp = player
track = true
once = false
search = false
end
end

--TRACKING
if track and path[#path] ~= target then
--GET SMALLEST
local smallest = 1000
local key = 0
if tiles[temp-1] ~= nil and tiles[temp-1].w == false and tiles[temp].y - tiles[temp-1].y == 0 then
if tiles[temp-1].numb < smallest then
smallest = tiles[temp-1].numb
key = temp-1
end
end
if tiles[temp-20] ~= nil and tiles[temp-20].w == false then
if tiles[temp-20].numb < smallest then
smallest = tiles[temp-20].numb
key = temp-20
end
end
if tiles[temp+20] ~= nil and tiles[temp+20].w == false then
if tiles[temp+20].numb < smallest then
smallest = tiles[temp+20].numb
key = temp+20
end
end
if tiles[temp+1] ~= nil and tiles[temp+1].w == false and tiles[temp].y - tiles[temp+1].y == 0 then
if tiles[temp+1].numb < smallest then
smallest = tiles[temp+1].numb
key = temp+1
end
end
if key ~= 0 then
table.insert(path, key)
temp = key
end
end
for i,v in pairs(path) do
tiles[v].path = true
end
end

function love.draw()
--DRAW TILES
for i,v in pairs(tiles) do
lg.setColor(0,0,0)
lg.rectangle("line", v.x, v.y, 25, 25)
--DRAW WALL
if v.w then
lg.setColor(0,0,0, 0.5)
lg.rectangle("fill", v.x, v.y, 25, 25)
end
--DRAW PATH
if v.path then
lg.setColor(0,0,1, 0.5)
lg.rectangle("fill", v.x, v.y, 25, 25)
end
end
--DRAW TARGET
if target ~= 0 then
lg.setColor(1,0,0)
lg.circle("fill", tiles[target].x + 12.5, tiles[target].y + 12.5, 5)
end
--DRAW PLAYER
if player ~= 0 then
lg.setColor(0,1,0)
lg.circle("fill", tiles[player].x + 12.5, tiles[player].y + 12.5, 5)
end
lg.setFont(font)
lg.setColor(0,0,0)
--[[lg.print("Press Q to add a target", 0, 500)
lg.print("Press Esc to close", 300, 500)
lg.print("Press W to add a starter", 0, 525)
lg.print("Press E to start pathfind", 0, 550)
lg.print("Press F to restart", 0, 575)
local font = lg.newFont(18)
lg.setFont(font)
lg.print("By G", 335, 575)]]--
end